/*******************************************************************
 * This is a demonstration of the use of a function template, with a 
 * function argument. Note the default value for the function.
 *******************************************************************/

#include<iostream>
#include<string>
#include<vector>

using namespace std;
	
template <class T>
T my_max(const T & a,const T & b,bool f(const T &,const T&)=operator>);

bool longer(const string & s1, const string & s2);

int main()
{
	string a(3,'z'), b(5, 'b');
	cout<<my_max(a,b, longer)<<endl;
	cout<<my_max(a,b)<<endl;
	return 0;

}

template <class T>
T my_max(const T & a, const T & b, bool f(const T &,const T&)=operator>)
{
	if(f(a,b))
		return a;
	return b;
}

bool longer(const string & s1, const string & s2)
{
	if(s1.size()>s2.size())
		return true;
	return false;
}
